SYS1/A 	ORG	4E00H
 ;	JUMP TABLE FOR SYS1
 	DW	BASIC2,BOOT,IN,INIT,LIB,OUT,PEEK,POKE,RESET,SYSTEM,TMEM,SPOOL,SET,DEVICE
 	ORG	4E20H
 ;  JUMP TABLE FOR SYS0
 LOOKUP	EQU	$
 ;	LIBRARY COMMAND LOOK UP TABLE
 ;10=1, 20=2, 30=3, 40=4, 50=5, 60=6, 70=7, 80=8
 ;90=9, A0=10, B0=11, C0=12, D0=13, E0=14, F0=16
 	DB	39H,3FH,11H,12H,3CH,83H,93H,1EH,34H,3DH
 	DB	0F1H,3AH,13H,14H,35H,15H,33H,36H,81H
 	DB	72H,16H,82H,17H,18H,37H,3BH,0A1H
 	DB	38H,92H,0A2H,19H,1DH,1CH,1AH,91H,1BH,71H
 LIBR	EQU	$
 ;  TABLE FOR SYS1/ASM
 ;  TABLE OF LIBRARY COMMANDS
 ;  HIGH BIT OF FIRST BYTE MUST BE SET
 	DB	'A'+80H,'TTRIB'
 	DB	'A'+80H,'UTO'
 	DB	'B'+80H,'ASIC2'
 	DB	'B'+80H,'OOT'
 	DB	'B'+80H,'UILD'
 	DB	'C'+80H,'HECK'
 	DB	'C'+80H,'OPY'
 	DB	'D'+80H,'EVICE'
 	DB	'D'+80H,'IR'
 	DB	'D'+80H,'UMP'
 	DB	'F'+80H,'ORMAT'
 	DB	'F'+80H,'REE'
 	DB	'I'+80H,'N'
 	DB	'I'+80H,'NIT'
 	DB	'K'+80H,'ILL'
 	DB	'L'+80H,'IB'
 	DB	'L'+80H,'IST'
 	DB	'L'+80H,'OAD'
 	DB	'M'+80H,'AKE'
 	DB	'O'+80H,'FFSET'
 	DB	'O'+80H,'UT'
 	DB	'P'+80H,'ATCH'
 	DB	'P'+80H,'EEK'
 	DB	'P'+80H,'OKE'
 	DB	'P'+80H,'RINT'
 	DB	'P'+80H,'ROT'
 	DB	'P'+80H,'URGE'
 	DB	'R'+80H,'ENAME'
 	DB	'R'+80H,'EORG'
 	DB	'R'+80H,'EPAIR'
 	DB	'R'+80H,'ESET'
 	DB	'S'+80H,'ET'
 	DB	'S'+80H,'POOL'
 	DB	'S'+80H,'YSTEM'
 	DB	'T'+80H,'EST'
 	DB	'T'+80H,'OPMEM'
 	DB	'Z'+80H,'AP'
 	DB	80H
 BOOT	HALT			;RESET SYSTEM
 LIB	LD	DE,LIBR		;LIBRARY COMMAND TABLE
 LIBLP	LD	A,(DE)		;GET FIRST BYTE
 	AND	7FH		;REMOVE HIGH BIT
 	RET	Z		;DONE
 LIBLP2	CALL	VOUT		;TO DISPLAY
 	CALL	PAUSE		;ANY PAUSE ?
 	INC	DE		;NEXT
 	LD	A,(DE)		;NEXT BYTE
 	BIT	7,A		;HIGH BIT SET ?
 	JR	Z,LIBLP2	;CONTINUE IF NOT
 	LD	A,9		;TAB CHARACTER
 	CALL	VOUT
 	JR	LIBLP
 BASIC2	DI			;DISABLE INTERRUPTS
 	XOR	A		;ZERO THE ACCUM
 	OUT	(0FFH),A	;SINGLE SIZE SCREEN
 	LD	HL,6D2H		;LEV II RESTART VECTORS
 	LD	DE,4000H	;WHERE THEY GO
 	LD	BC,36H		;LENGTH OF DATA BLOCK
 	LDIR			;MOVE IT
 	LD	B,27H		;ANOTHER BLOCK
 BASLP	LD	(DE),A		;ZERO THE BLOCK
 	INC	DE
 	DJNZ	BASLP
 	JP	75H		;GO LEV II BASIC
 ;PARERR	LD	A,43		;PARAMETER ERROR CODE
 ;	JP	ERROR		;GO
 PARERR	CALL	PRINT		;REST OF LINE
 	LD	HL,PARMSG	;PARAMETER ERROR
 	JP	PRINT		;DISPLAY & RETURN
 PARMSG	DB	'Parameter Error.',13
 PARER1	CALL	PRINT		;PRINT BAD TEXT
 	LD	HL,PARE1
 	JP	PRINT
 PARER2	CALL	PRINT
 	LD	HL,PARE2
 	JP	PRINT
 PARER3	CALL	PRINT
 	LD	HL,PARE3
 	JP	PRINT
 PARER4	CALL	PRINT
 	LD	HL,PARE4
 	JP	PRINT
 PARER5	CALL	PRINT
 	LD	HL,PARE5
 	JP	PRINT
 PARE1	DB	'Numerical expression error.',13
 PARE2	DB	'Invalid drive #.',13
 PARE3	DB	'Missing information.',13
 PARE4	DB	'Number too large for command.',13
 PARE5	DB	'Invalid information.',13
 IN	RST	8		;POSITION HL
 	JP	C,PARER3	;PARAMETER ERROR
 	CALL	VALUE		;CONVERT TO NUMERIC
 	JP	C,PARER1	;BAD VALUE
 	JP	NZ,PARER4	;HIGH BYTE NOT ZERO
 	LD	A,C
 	LD	(PORT1),A
 	IN	A,(C)		;GET A BYTE
 	LD	(INP),A		;SAVE BYTE
 	PUSH	AF		;SAVE BYTE
 	CALL	ASCII		;MAKE IT ASCII
 	LD	HL,(CURSOR)	;GET CURSOR POSITION
 	LD	(HL),A		;PRINT HIGH DIGIT
 	INC	HL
 	LD	(HL),C
 	INC	HL
 	LD	(HL),B
 	POP	AF		;RESTORE BYTE
 	CALL	HEXCV		;MAKE IT HEX
 	INC	HL
 	INC	HL
 	LD	(HL),'-'
 	INC	HL
 	INC	HL
 	LD	(HL),C
 	INC	HL
 	LD	(HL),B
 	INC	HL
 	LD	(HL),'H'
 	LD	A,0DH		;SEND CARRIAGE RETURN
 	JP	VOUT		;PRINT AND RETURN
 OUT	RST	8		;POSITON HL
 	JP	C,PARER3
 	CALL	VALUE
 	JP	C,PARER1
 	JP	NZ,PARER2
 	LD	A,C		;GET PORT
 	LD	(PORT2),A	;SAVE IT
 	RST	8		;POSTION TO NEXT NUMBER
 	JP	C,PARER3
 	CALL	VALUE		;GET VALUE AGAIN
 	JP	C,PARER1
 	JP	NZ,PARER2
 	LD	A,C		;SAVE BYTE TO SEND
 	LD	(PRTOUT),A	;SAVE IT TOO
 	LD	A,(PORT2)	;GET PORT BACK
 	LD	B,A
 	LD	A,C
 	LD	C,B
 	OUT	(C),A		;SEND BYTE TO PORT
 	RET			;DONE
 INIT	DI			;DISABLE A MOMENT
 	JP	SETUP		;REINITIALIZE
 SYSTEM	RST	8		;POSITION HL
 	JP	C,PARER3
 	CP	'?'		;INQUIRY ?
 	JR	Z,SHOSYS	;SHOW WHAT'S SET
 	CP	':'		;SPECIFY A DRIVE ?
 	JP	NZ,PARER3
 	INC	HL		;BUMP POINTER TO DRIVE
 	LD	A,(HL)		;GET A DRIVE
 	CALL	FIXDRV		;SET IT UP
 	JP	C,PARER2	;BAD DRIVE SPECIFIED
 	LD	A,(DRIV)	;GET BIT PATTERN
 	LD	(SYSDRV),A	;SAVE INTO SYS DRIVE
 	RET			;DONE
 SHOSYS	LD	A,(SYSDRV)	;GET THE BYTE
 	CALL	DRVASC		;CONVERT TO ASCII
 	CALL	VOUT		;PRINT ON DISPLY
 	LD	A,0DH
 	JP	VOUT		;PRINT CARRIAGE RETURN
 TMEM	RST	8
 	JP	C,PARER3
 	CP	'?'
 	JR	Z,TMEMSHO
 	CALL	VALUE
 	JP	C,PARER1
 	LD	(TOPMEM),BC		;NEW HIGH MEM
 	RET
 TMEMSHO	LD	A,(TOPMEM)		;GET LSB
 	CALL	HEXCV			;MAKE IT HEX
 	PUSH	BC
 	LD	A,(TOPMEM+1)		;GET MSB
 	CALL	HEXCV			;MAKE IT ASCII
 	LD	HL,(CURSOR)		;GET CURSOR POSIT
 	LD	(HL),C			;HIGH OF MSB
 	INC	HL
 	LD	(HL),B
 	INC	HL
 	POP	BC			;GET BACK LOW NIB
 	LD	(HL),C
 	INC	HL
 	LD	(HL),B
 	INC	HL
 	LD	(HL),'H'		;FOR HEX
 	LD	A,13			;PRINT CR
 	JP	VOUT
 POKE	RST	8
 	JP	C,PARER3
 	CALL	VALUE
 	JP	C,PARER1
 	LD	(ADDRESS),BC	;SAVE ADDRESS
 	RST	8
 	JP	C,PARER3
 	CALL	VALUE
 	JP	C,PARER1
 	LD	A,C		;GET LSB
 	LD	BC,(ADDRESS)	;GET ADDRESS
 	LD	(BC),A		;POKE IT
 	RET
 ADDRESS	DW	0		;TEMPORARY STORAGE
 PEEK	RST	8
 	JP	C,PARER3
 	CALL	VALUE
 	JP	C,PARER1
 	LD	A,(BC)		;GET THE BYTE
 	CALL	HEXCV		;MAKE IT ASCII
 	LD	HL,(CURSOR)	;WHERE TO DISPLAY IT
 	LD	(HL),C		;PUT LSB
 	INC	HL
 	LD	(HL),B
 	INC	HL
 	LD	(HL),'H'	;FOR HEX
 	LD	A,13
 	JP	VOUT		;PRINT CR
 SET	RST	8
 	JP	C,PARER3
 	LD	DE,PARDEV
 	RST	18H
 	JP	Z,PARER5
 	LD	(INKEYS),A	;SAVE DEVICE NAME
 	RST	20H		;PASS THROUGH STRING
 	JP	C,PARER3
 	LD	DE,PARDEV
 	RST	18H
 	JP	Z,SETADDR
 	CALL	POSDEV		;POINT TO DEVICE
 	PUSH	HL		;SAVE DEST
 	LD	A,(INKEYS)
 	CALL	POSDEV
 	EX	DE,HL
 	POP	HL
 	LD	B,3
 POSDLP	LD	A,(DE)		;GET BYTE FROM DCB
 	LD	(HL),A		;PUT INTO DCB
 	INC	HL
 	INC	DE
 	DJNZ	POSDLP
 	RET			;DEVICE IS SET
 SETADDR	CALL	VALUE		;SET TO NUMERIC ?
 	JP	C,PARER5
 	LD	A,(INKEYS)
 	CALL	POSDEV
 	INC	HL
 	LD	(HL),C
 	INC	HL
 	LD	(HL),B
 	RET			;FINISHED
 POSDEV	CP	1		;KEYBOARD ?
 	LD	HL,KIDCB
 	LD	DE,KEYIN
 	LD	B,80H
 	RET	Z
 	CP	2
 	LD	HL,DODCB
 	LD	DE,VOUT
 	LD	B,81H
 	RET	Z
 	LD	HL,PRDCB
 	LD	DE,POUT
 	LD	B,1
 	RET
 RESET	RST	8
 	JP	C,PARER3
 	LD	DE,PARDEV
 	RST	18H
 	JP	Z,PARER5
 	CALL	POSDEV
 	LD	(HL),B
 	INC	HL
 	LD	(HL),E		;LSB ADDRESS
 	INC	HL
 	LD	(HL),D		;MSB ADDRESS
 	RET
 PARDEV	DB	'*'+80H,'KI'
 	DB	'*'+80H,'DO'
 	DB	'*'+80H,'PR'
 	DB	80H
 DEVICE	LD	HL,DEVK
 	CALL	PRINT
 	LD	HL,KIDCB
 	CALL	SHOADD
 	LD	HL,DEVD
 	CALL	PRINT
 	LD	HL,DODCB
 	CALL	SHOADD
 	LD	HL,DEVP
 	CALL	PRINT
 	LD	HL,PRDCB
 SHOADD	LD	A,(HL)		;GET IN OR OUT FLAG
 	INC	HL		;POINT TO NEXT BYTE
 	INC	HL		;POINT TO DRIVER MSB
 	CALL	SHODIR		;GET DIRECTION
 	LD	A,(HL)
 	CALL	HEXCV
 	LD	A,C
 	CALL	VOUT
 	LD	A,B
 	CALL	VOUT
 	DEC	HL
 	LD	A,(HL)
 	CALL	HEXCV
 	LD	A,C
 	CALL	VOUT
 	LD	A,B
 	CALL	VOUT
 	LD	A,13
 	JP	VOUT
 DEVK	DB	'*KI ',3
 DEVD	DB	'*DO ',3
 DEVP	DB	'*PR ',3
 SHODIR	BIT	7,A		;INPUT ?
 	CALL	SHOIN		;SHOW IT
 	CALL	SHOEQ		;EQUAL SIGN
 	BIT	0,A		;OUTPUT
 	CALL	SHOOUT
 	LD	A,20H
 	JP	VOUT
 SHOEQ	PUSH	AF
 	LD	A,'='
 	CALL	VOUT
 	POP	AF
 	RET
 SHOIN	PUSH	AF
 	JR	Z,SHOSP
 	LD	A,'<'
 SHOCONT	CALL	VOUT
 	POP	AF
 	RET
 SHOOUT	PUSH	AF
 	JR	Z,SHOSP
 	LD	A,'>'
 	JR	SHOCONT
 SHOSP	LD	A,20H
 	CALL	VOUT
 	POP	AF
 	RET
 SPOOL	LD	HL,SPMSG
 	JP	PRINT
 SPMSG	DB	'Spooler not completed.',13
 	END
 	POP	AF
 	RET
 SHOOUT	PUSH	AF
 	JR	Z,SHOSP
 	LD	A,'>'
 	JR	SHOCONT
 SHOSP	LD	A,20H
 	CALL	VOUT
 	POP	AF
 	RET
 SPOOL	LD	HL,SPMSG
